#ifndef COMPILER_H
#define COMPILER_H

#include <iostream>
#include <string>
#include <sstream>
#include <fstream>

class Compiler
{
public:
	std::stringstream errStream;
	int line;
	unsigned char* code, *codeP, *codeE;
	std::istream& input;
	
	Compiler(std::istream& input);
	~Compiler();

	bool Compile();
	void CompileStatement();
	void CompileInteger();
	void CompileString();
	void CompileExpression();
	
	void EmitOpcode(int index);
	void EmitInteger(int i);
	void EmitString(const std::string& str);
	void ShrinkCode();
	void ReserveCode(int extra);
	void EatLine();
	void NextWord(std::string& next);
};

#endif
