#ifndef GAME_H
#define GAME_H

#include <allegro.h>

#include <map>

#include "GameState.h"
#include "Scene.h"
#include "Character.h"

class Game : public GameState
{
public:
	std::string filename;
	Scene* myScene, *next;
	Character* player;
	int clickX, clickY;
	bool inClick;
	int walkX, walkY;
	bool inWalk;
	std::map<std::string, int> gameVars;
	std::map<std::string, std::map<std::string, int> > sceneVars;

public:
	Game();
	~Game();

	GameState *RunLogic();
	void Draw(BITMAP *dest);
	
	bool SafeToSave();
	void GoToScene(const std::string& filename);
	
	void New();
	bool Load(const std::string& fileName);
	bool Save(const std::string& location);
};

#endif
