#include <allegro.h>
#include <string>

#include "GameState.h"
#include "Game.h"
#include "Menu.h"

using namespace std;

const int Menu::numChoices = 3;
const string Menu::choices[numChoices] =
{
	"Start",
	"Load",
	"Quit"
};

static const int menuWidth = 150; // used to center it on the screen
static const int menuHeight = 80;

Menu::Menu() : tickerSpeed(1), 
				tickerMsg("WELCOME TO OMG GARBAGE BY BAF AND CGAMESPLAY! TO PLAY, USE YOUR MOUSE TO MOVE AND INTERACT WITH THE WORLD. "
						  "OMG GARBAGE WAS WRITTEN FOR THE TINS 2007 COMPETITION, IN 72 HOURS. OH MY GOD, THIS GAME IS SO BEHIND "
						  "SCHEDULE I REALLY DON'T THINK IT WILL GET DONE. OH WELL, THIS IS BAF, SIGNING OUT."),
				tickerLen(text_length(font, tickerMsg.c_str())), tickerPos(-320),
				curChoice(0)
{
	
}

Menu::~Menu()
{
}


GameState *Menu::RunLogic()
{
	if(key[KEY_ESC])
		return NULL;

	static bool lKU = false;
	static bool lKD = false;

	if(key[KEY_UP] && !lKU && curChoice > 0)
	{
		--curChoice;
		lKU = true;
	}
	else if(!key[KEY_UP])
		lKU = false;

	if(key[KEY_DOWN] && !lKD && curChoice < (numChoices - 1))
	{
		++curChoice;
		lKD = true;
	}
	else if(!key[KEY_DOWN])
		lKD = false;

	static int lmx = 0, lmy = 0;
	int mx = mouse_x / (SCREEN_W / 320), my = mouse_y / (SCREEN_H / 240);
	int left = (320 - menuWidth) / 2, top = (240 - menuHeight) / 2;

	if(lmx != mx || lmy != my)
	{
		lmx = mx;
		lmy = my;

		if(mx > (left + 60) && mx < (left + menuWidth))
			for(int i = 0; i < numChoices; ++i)
				if(my > (top + ((i + 1) * (menuHeight / (numChoices + 1)))) && my < (top + text_height(font) + ((i + 1) * (menuHeight / (numChoices + 1)))))
					curChoice = i;
	}

	static bool clickDone = false;
	static bool clickStart = false;

	if(mouse_b & 1 && !clickStart)
		clickStart = true;

	if(!(mouse_b & 1) && clickDone)
		clickDone = clickStart = false;

	if(!(mouse_b & 1) && clickStart)
		clickDone = true, clickStart = false;

	if(key[KEY_ENTER] || clickDone)
	{
		switch(curChoice)
		{
		case 0: // start
			{
				Game *g = new Game();
				g->New();
				delete this;
				return g;
			}

		case 1: // load
			{
				char fn[512];
				memset(fn, 0, 512);
				if(file_select_ex("Select Game to Load", fn, "dat", 510, 320, 240) == 0)
					break;

				Game *g = new Game();
				if(g->Load(fn))
				{
					delete this;
					return g;
				}

				alert("Load Failed", "", "Failed to load the specified game.", "&OK", NULL, 'o', 0);

				delete g;
				break;
			}

		case 2: // quit
			delete this;
			return NULL;
		}
	}

	tickerPos += tickerSpeed;
	if(tickerPos >= tickerLen)
		tickerPos = -320;

	return this;
}

void Menu::Draw(BITMAP *dest)
{
	static const int left = (dest->w - menuWidth) / 2;
	static const int top = (dest->h - menuHeight) / 2;
	static const int right = left + menuWidth;
	static const int bottom = top + menuHeight;

	static const int yPerChoice = menuHeight / (numChoices + 1);

	rect(dest, left, top, right, bottom, makecol(128, 0, 128));

	for(int i = 0; i < numChoices; ++i)
		textprintf_ex(dest, font, left + 60, top + ((i + 1) * yPerChoice), makecol(255, 255, 255), -1, "%s", choices[i].c_str());

	textprintf_ex(dest, font, left + 20, top + ((curChoice + 1) * yPerChoice), makecol(255, 255, 255), -1, "-->");

	textprintf_ex(dest, font, 1 - tickerPos, dest->h - text_height(font), makecol(255, 255, 255), -1, "%s", tickerMsg.c_str());

	int mx = mouse_x / (SCREEN_W / 320), my = mouse_y / (SCREEN_H / 240);
	hline(dest, mx - 6, my, mx - 3, makecol(255, 255, 255));
	hline(dest, mx + 3, my, mx + 6, makecol(255, 255, 255));
	vline(dest, mx, my - 6, my - 3, makecol(255, 255, 255));
	vline(dest, mx, my + 3, my + 6, makecol(255, 255, 255));
}
