#ifndef SCRIPT_H
#define SCRIPT_H

#include <allegro.h>
#include <assert.h>

#include <string>
#include <list>
#include <vector>

class Object;
class Scene;
class ScriptData;

class Script
{
public:
	ScriptData* data;
	BITMAP* plane;
	Object* context;
	Object* saveContext;
	Scene* scene;
	int sleeping;

public:
	Script();
	Script(const Script& other);
	~Script();
	
	Script& operator =(const Script& rhs)
	{
		assert(false);
		return *this;
	}

	bool CompileFile(const std::string& content, std::string& error);
	bool Compile(const std::string& content, std::string& error);
	void Save(PACKFILE* pf);
	bool Load(Object* context, PACKFILE* pf);
	void SetContext(Object* context);
	void SetScene(Scene* scene);
	
	void Reset();
	bool Logic();

private:
	bool CompileInternal(std::istream& in, std::string& error);
};

#endif
