#include <allegro.h>

#include "Constants.h"

#include "Timer.h"

#include "GameState.h"
#include "Game.h"
#include "Menu.h"

int main()
{
	allegro_init();
	
	install_keyboard();
	install_timer();
	install_mouse();

	set_config_file("../speedhack.ini");
	int gfxC = get_config_id("graphics", "card", GFX_AUTODETECT_WINDOWED);
	int gfxD = get_config_int("graphics", "depth", 32);
	int gfxW = get_config_int("graphics", "width", 640);
	int gfxH = get_config_int("graphics", "height", 480);

	set_color_depth(gfxD);
	
	if(set_gfx_mode(gfxC, gfxW, gfxH, 0, 0))
	{
		allegro_message("Could not set graphics mode:\n%s", allegro_error);
		return -1;
	}

	Timer::InstallTimer();

	GameState *state = new Menu();
	//GameState *state = new Game();
	BITMAP *buffer = create_bitmap(320, 240);

	while(state)
	{
		while(Timer::ticks > 0)
		{
			if(state)
				state = state->RunLogic();

			Timer::ticks = 0;
		}

		if(state)
			state->Draw(buffer);

		stretch_blit(buffer, screen, 0, 0, 320, 240, 0, 0, SCREEN_W, SCREEN_H);
		clear_bitmap(buffer);

		if(Timer::ticks == 0)
			rest(1);
	}

	return 0;
}
END_OF_MAIN()
